import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ClinicAppointment, ClinicAppointmentParam } from './model';

/**
 * 分页查询挂号
 */
export async function pageClinicAppointment(params: ClinicAppointmentParam) {
  const res = await request.get<ApiResult<PageResult<ClinicAppointment>>>(
    '/clinic/clinic-appointment/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询挂号列表
 */
export async function listClinicAppointment(params?: ClinicAppointmentParam) {
  const res = await request.get<ApiResult<ClinicAppointment[]>>(
    '/clinic/clinic-appointment',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加挂号
 */
export async function addClinicAppointment(data: ClinicAppointment) {
  const res = await request.post<ApiResult<unknown>>(
    '/clinic/clinic-appointment',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改挂号
 */
export async function updateClinicAppointment(data: ClinicAppointment) {
  const res = await request.put<ApiResult<unknown>>(
    '/clinic/clinic-appointment',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除挂号
 */
export async function removeClinicAppointment(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/clinic/clinic-appointment/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除挂号
 */
export async function removeBatchClinicAppointment(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    '/clinic/clinic-appointment/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询挂号
 */
export async function getClinicAppointment(id: number) {
  const res = await request.get<ApiResult<ClinicAppointment>>(
    '/clinic/clinic-appointment/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
